diff --git a/libr/bin/mangling/swift-sd.c b/libr/bin/mangling/swift-sd.c
index 6a14ab82dc3..bd2586bc5dd 100644
--- a/libr/bin/mangling/swift-sd.c
+++ b/libr/bin/mangling/swift-sd.c
@@ -448,7 +448,7 @@ R_API char *r_bin_demangle_swift(const char *s, bool syscmd) {
 					break;
 				case '_':
 					// it's return value time!
-					p = resolve (types, q+1, &attr); // type
+					p = resolve (types, q + 1, &attr); // type
 					//printf ("RETURN TYPE %s\n", attr);
 					break;
 				default:
@@ -460,6 +460,10 @@ R_API char *r_bin_demangle_swift(const char *s, bool syscmd) {
 					if (attr && !strcmp (attr, "generic")) {
 						is_generic = 1;
 					}
+					if (len < 1 || len > 256) {
+						// invalid length
+						break;
+					}
 					//printf ("TYPE: %s LEN %d VALUE %s\n",
 					//	attr, len, getstring (q, len));
 					if (!len) {
@@ -485,7 +489,7 @@ R_API char *r_bin_demangle_swift(const char *s, bool syscmd) {
 						retmode = 1;
 						len++;
 					}
-					if (len <= (q_end-q)  && q[len]) {
+					if (len <= (q_end - q) && q[len]) {
 						const char *s = getstring (q, len);
 						if (s && *s) {
 							if (is_first) {	
